﻿# Enable mailing for Test-StorageHealth script from Jose Barreto
# https://gallery.technet.microsoft.com/scriptcenter/Test-StorageHealthps1-66d84fd4
# Version 1.0 by j.kappen@rachfahl.de & c.rachfahl@rachfahl.de - http://www.hyper-v-server.de

# if you want to get the results mailed, configure $SMTPServer
[string]$SMTPServer = ""
[string]$ToEMail = ""
[string]$FromEMail = ""
#[string]$SMTPServer = "server.domain.de"
#[string]$ToEmail = "Support <support@domain.de>"
#[string]$FromEmail = "StorageHealth $env:computername <StorageHealth@" + ($env:computername).ToLower() + "." + ($env:USERDNSDOMAIN).ToLower() + ">"

# where should the logfile be saved?
[String]$LogFile = "C:\Windows\Logs\StorageHealth.log"

# create tempfiles
[string]$TmpFile = [System.IO.Path]::GetTempFileName()
[string]$TmpFile2 = [System.IO.Path]::GetTempFileName()

# path to script
# [String]$ScriptPath = "C:\tools\Test-StorageHealth.ps1 -ZipPrefix C:\system"
[String]$ScriptPath = "C:\tools\Test-StorageHealth.ps1"

# set Get-Date output format (infos: http://msdn.microsoft.com/en-us/library/system.globalization.datetimeformatinfo(VS.85).aspx)
[String]$DateOutputFormat = "dddd, dd MMMM yyyy HH:mm:ss"

# write the start timestamp into $Tmpfile
$startDateStr = Get-Date -Format $DateOutputFormat
Write-Output "`n" | Out-File $TmpFile
Write-Output "Health check started at: $startDateStr" | Out-File $TmpFile -Append
Write-Output "`n" | Out-File $TmpFile -Append

# start the health script and log it into $Tmpfile2
Start-Process -FilePath "C:\windows\system32\WindowsPowerShell\v1.0\powershell.exe" -ArgumentList "$ScriptPath" -NoNewWindow:$true -Wait -RedirectStandardOutput $TmpFile2

# append $TmpFile2 to $TmpFile
Get-Content $TmpFile2 | Out-File $TmpFile -Append

# write the stop timestamp into the $TmpFile
$stopDateStr = Get-Date  -Format $DateOutputFormat
Write-Output "`n`n" | Out-File $TmpFile -Append
Write-Output "Health check finished at: $stopDateStr" | Out-File $TmpFile -Append

# apend TmpFile to LogFile
Get-Content $TmpFile | Out-File $LogFile -Append

# mail the result if $SMTPServer is not empty
if(($SMTPServer -ne "") -and ($ToEMail -ne "") -and ($FromEMail -ne "")){

    $Message = Get-Content $TmpFile
    $MailBody = $Message | Out-String 
    Send-MailMessage -SmtpServer $SMTPServer -From $FromEMail -To $ToEmail -Subject "Results of Test-StorageHealth on $env:computername" -Body $MailBody
}
